package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLScheduleExtensionNode_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLScheduleExtensionNode extends ISLScheduleNode  {
	
	/* @generated */
	protected ISLScheduleExtensionNode(long ptr) {
		/*** PROTECTED REGION ID(ISLScheduleExtensionNode_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLScheduleExtensionNode build(long ptr) {
		return new ISLScheduleExtensionNode(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLScheduleExtensionNode_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_schedule_node_from_extension 
	 * 
	@take extension
	 * @generated
	**/
	 public static ISLScheduleExtensionNode buildFromExtensionMap(ISLUnionMap extension) { 
		/*** PROTECTED REGION ID(static_isl_schedule_node_from_extension) DISABLED START ***/
		ISLScheduleExtensionNode res;
		
		synchronized(LOCK) {
			checkParameters(extension);
			try {
				res = (ISLScheduleExtensionNode)ISLScheduleExtensionNode.build(ISLNative.isl_schedule_node_from_extension(getNativePtr(extension)));
			} finally {
				taken(extension);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_schedule_node_extension_get_extension 
	 * 
	 * @generated
	**/
	public ISLUnionMap getExtension() {
		/*** PROTECTED REGION ID(isl_schedule_node_extension_get_extension) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionMap.build(ISLNative.isl_schedule_node_extension_get_extension(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLScheduleNodeVisitor visitor) {
		visitor.visitISLScheduleExtensionNode(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLScheduleExtensionNode_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
